"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    function compareArray(a, b) {
        if (a.length !== b.length) {
            return false;
        }
        var length = a.length;
        var temp = true;
        for (var i = 0; i < length; i++) {
            if ((0, _typeof3.default)(a[i]) === (0, _typeof3.default)(b[i])) {
                if (b.indexOf(a[i]) === -1 || a.indexOf(b[i]) === -1) {
                    temp = false;
                }
            } else {
                return false;
            }
        }
        if (temp) {
            return temp;
        }
        for (var _i = 0; _i < length; _i++) {
            if (!compare(a[_i], b[_i])) {
                return false;
            }
        }

        return true;
    }

    function keySort(obj) {
        var newkey = (0, _keys2.default)(obj).sort();
        var newObj = {};
        for (var i = 0; i < newkey.length; i++) {
            newObj[newkey[i]] = obj[newkey[i]];
        }
        return newObj;
    }

    function compareObject(obj1, obj2) {
        var a = keySort(obj1);
        var b = keySort(obj2);
        var keya = (0, _keys2.default)(a);
        var keyb = (0, _keys2.default)(b);

        if (keya.length !== keyb.length) {
            return false;
        }

        return keya.every(function (key) {
            if (!compare(a[key], b[key])) {
                return false;
            }
            return true;
        });
    }

    function compare(a, b) {
        if (a === b) {
            return true;
        }

        if ((typeof a === "undefined" ? "undefined" : (0, _typeof3.default)(a)) !== (typeof b === "undefined" ? "undefined" : (0, _typeof3.default)(b)) || a === null || b === null) {
            return false;
        }

        if (Array.isArray(a)) {
            if (!Array.isArray(b)) {
                return false;
            }
            return compareArray(a, b);
        }

        if ((typeof a === "undefined" ? "undefined" : (0, _typeof3.default)(a)) === "object") {
            return compareObject(a, b);
        }
        return false;
    }

    return compare;
}();