'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = function () {
    return new (Function.prototype.bind.apply($date, [null].concat(Array.prototype.slice.call(arguments))))();
};

var _dateFns = require('date-fns');

var _dateFns2 = _interopRequireDefault(_dateFns);

var _zh_cn = require('date-fns/locale/zh_cn');

var _zh_cn2 = _interopRequireDefault(_zh_cn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var startsWith = function startsWith(string, target, position) {
    var length = string.length;

    position = position == null ? 0 : position;
    if (position < 0) {
        position = 0;
    } else if (position > length) {
        position = length;
    }
    target = '' + target;
    return string.slice(position, position + target.length) == target;
};

var date = null;
var $date = function $date() {
    var _date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();

    var onlyday = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (arguments.length === 1 && typeof arguments[0] === 'boolean') {
        onlyday = arguments[0];
        _date = new Date();
    }
    if ((typeof _date === 'undefined' ? 'undefined' : (0, _typeof3.default)(_date)) === 'object' && _date._flag) {
        return _date;
    }
    if (onlyday) {
        _date = _dateFns2.default.format(_date, 'YYYY-MM-DD');
    }
    date = _dateFns2.default.parse(_date);
};

var _loop = function _loop(key) {
    if (startsWith(key, 'add') || startsWith(key, 'sub')) {
        $date.prototype[key] = function (num) {
            date = _dateFns2.default[key](date, num);
            return this;
        };
    } else if (startsWith(key, 'endOf') || startsWith(key, 'get') || startsWith(key, 'set') || startsWith(key, 'lastDayOf') || startsWith(key, 'startOf')) {
        $date.prototype[key] = function () {
            return _dateFns2.default[key](date);
        };
    } else if (startsWith(key, 'differenceIn')) {
        $date.prototype[key] = function (dirtyDateLeft, dirtyDateRight) {
            if (dirtyDateRight === undefined) {
                dirtyDateRight = dirtyDateLeft;
                dirtyDateLeft = date;
            }
            return _dateFns2.default[key](dirtyDateLeft, dirtyDateRight);
        };
    } else if (['closestIndexTo', 'closestTo'].indexOf(key) > -1) {
        $date.prototype[key] = function (datesArray) {
            return _dateFns2.default[key](date, datesArray);
        };
    } else if (key === 'format') {
        $date.prototype[key] = function (dirtyFormatStr) {
            return _dateFns2.default[key](date, dirtyFormatStr, { locale: _zh_cn2.default });
        };
    } else if (startsWith(key, 'is')) {
        $date.prototype[key] = function () {
            if (arguments.length === 0) {
                return _dateFns2.default[key](date);
            } else if (arguments.length === 1) {
                return _dateFns2.default[key](date, arguments[0]);
            } else {
                return _dateFns2.default[key].apply(_dateFns2.default, arguments);
            }
        };
    } else {
        $date.prototype[key] = _dateFns2.default[key];
    }
};

for (var key in _dateFns2.default) {
    _loop(key);
}

$date.prototype.getTimeStamp = function () {
    return parseInt(date.getTime() / 1000);
};
$date.prototype.ymd = function () {
    date = _dateFns2.default.parse(date.format('YYYY-MM-DD'));
    return this;
};
$date.prototype.getWeekRange = function (week) {
    var curr = _dateFns2.default.getISOWeek(date);
    var w = (week ? week : curr) - curr;
    var start = _dateFns2.default.startOfISOWeek(_dateFns2.default.addWeeks(date, w));
    var end = _dateFns2.default.endOfISOWeek(_dateFns2.default.addWeeks(date, w));
    return { start: start, end: end };
};
$date.prototype.getMonthRange = function () {
    return {
        start: _dateFns2.default.startOfMonth(date),
        end: _dateFns2.default.endOfMonth(date)
    };
};

$date.prototype.toString = function () {
    return date;
};
$date.prototype._flag = true;