'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

var _ajax = require('../ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _modal = require('./modal');

var _modal2 = _interopRequireDefault(_modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    install: function install(Vue, $ele, Config) {
        if ($ele) {
            var cfg = (0, _modal2.default)($ele);
            var events = function events(opt) {
                return {
                    mask: function mask() {
                        if (typeof opt.mask === 'string') {
                            cfg.mask(opt.mask);
                        } else if (typeof opt.mask === 'function') {
                            opt.mask(true);
                        } else {
                            return false;
                        }
                    },
                    unmask: function unmask() {
                        if (typeof opt.mask === 'string') {
                            cfg.unmask();
                        } else if (typeof opt.mask === 'function') {
                            opt.mask(false);
                        } else {
                            return false;
                        }
                    }
                };
            };
            (0, _assign2.default)(_utils2.default, cfg, {
                query: function query(options) {
                    if (!options.err) {
                        options.err = function (res) {
                            cfg.info(res.msg || '未知错误');
                        };
                    }
                    options = _utils2.default.apply({}, events(options), options);
                    if (options.confirm) {
                        var yes = function yes() {
                            delete options.confirm;
                            _ajax2.default.query(options);
                        };
                        if (typeof options.confirm === 'string') {
                            cfg.confirm(options.confirm, yes);
                        } else if ((0, _typeof3.default)(options.confirm) === 'object') {
                            if ((0, _typeof3.default)(options.confirm.yes) === 'object') {
                                yes = { text: options.confirm.yes.text || '确定', handler: yes };
                            }
                            cfg.confirm(options.confirm.title || '', options.confirm.content || '', yes, options.confirm.no);
                        } else {
                            yes();
                        }
                    } else {
                        _ajax2.default.query(options);
                    }
                },
                fetch: function fetch(options) {
                    if (options.confirm) {
                        delete options.confirm;
                    }
                    options = _utils2.default.apply({}, events(options), options);
                    return _ajax2.default.fetch(options);
                }
            });
        }

        Vue.prototype.$ = _utils2.default;
        Vue.$ = _utils2.default;
        window.$ = _utils2.default;

        if (Config) {
            Vue.prototype.$cfg = Config;
            Vue.$cfg = Config;
            window.$cfg = Config;
        }
    }
};