'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QiniuClient = function () {
    function QiniuClient(_ref) {
        var _ref$server = _ref.server,
            server = _ref$server === undefined ? 'http://upload.qiniu.com' : _ref$server,
            _ref$buckets = _ref.buckets,
            buckets = _ref$buckets === undefined ? [] : _ref$buckets,
            api = _ref.api,
            _ref$accessToken = _ref.accessToken,
            accessToken = _ref$accessToken === undefined ? '' : _ref$accessToken;
        (0, _classCallCheck3.default)(this, QiniuClient);

        this.server = server;
        this.buckets = buckets;
        this.tokens = [];
        this.api = api;

        this.queryAccessToken = function () {
            if (typeof accessToken === 'string') {
                return accessToken;
            } else if (typeof accessToken === 'function') {
                return accessToken();
            } else {
                return '';
            }
        };
    }

    (0, _createClass3.default)(QiniuClient, [{
        key: 'url',
        value: function url(bucket, key) {
            var style = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
            var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '';

            var item = this.buckets.find(function (a) {
                return a.name == bucket;
            });
            if (item) {
                var url = item.uri + '/' + key;
                if (!_utils2.default.isEmpty(style)) {
                    url += '?' + style;
                }
                if (!_utils2.default.isEmpty(params)) {
                    url += (url.indexOf('?') == -1 ? '?' : '&') + params;
                }
                return url;
            } else {
                console.warn('没有找到' + bucket + '对应的url');
                return 'data:image/gif;base64,R0lGODlhAQABAID/AMDAwAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==';
            }
        }
    }, {
        key: 'query',
        value: function query(value, x_access_token) {
            var _this = this;

            return new _promise2.default(function (resolve) {
                (0, _axios2.default)({
                    url: _this.api,
                    data: value,
                    method: 'post',
                    timeout: 10 * 1000,
                    responseType: 'json',
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'x-access-token': x_access_token
                    }
                }).then(function (res) {
                    try {
                        if (res.status == 200) {
                            if (res.data.success) {
                                resolve(res.data.data);
                            } else {
                                console.warn('请求七牛token失败', res.data);
                                resolve({ value: '', expire: 0 });
                            }
                        } else {
                            console.warn('请求七牛token失败', res.data);
                            resolve({ value: '', expire: 0 });
                        }
                    } catch (e) {
                        console.warn('请求七牛token失败', e);
                        resolve({ value: '', expire: 0 });
                    }
                }).catch(function (error) {
                    console.warn('请求七牛token失败', error);
                    resolve({ value: '', expire: 0 });
                });
            });
        }
    }, {
        key: 'file2base64',
        value: function file2base64(file) {
            return new _promise2.default(function (resolve) {
                var reader = new FileReader();
                reader.onload = function (e) {
                    resolve(this.result);
                };
                reader.readAsDataURL(file);
            });
        }
    }, {
        key: 'getToken',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                var value,
                    _value,
                    bucket,
                    key,
                    expires,
                    body,
                    old,
                    token,
                    _args = arguments;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                value = { bucket: '', key: '', expires: 3600, body: null };

                                if (!(_args.length === 1 && typeof _args[0] === 'string')) {
                                    _context.next = 5;
                                    break;
                                }

                                value.bucket = _args[0];
                                _context.next = 16;
                                break;

                            case 5:
                                if (!(_args.length === 2 && typeof _args[0] === 'string' && typeof _args[1] === 'string')) {
                                    _context.next = 10;
                                    break;
                                }

                                value.bucket = _args[0];
                                value.key = _args[1];
                                _context.next = 16;
                                break;

                            case 10:
                                if (!(_args.length === 1 && (typeof _args === 'undefined' ? 'undefined' : (0, _typeof3.default)(_args)) === 'object')) {
                                    _context.next = 14;
                                    break;
                                }

                                value = _utils2.default.applyIf(value, _args[0]);
                                _context.next = 16;
                                break;

                            case 14:
                                console.warn('七牛token传参异常');
                                return _context.abrupt('return', '');

                            case 16:
                                _value = value, bucket = _value.bucket, key = _value.key, expires = _value.expires, body = _value.body;
                                old = this.tokens.find(function (a) {
                                    return a.id === bucket + key;
                                });

                                if (!old) {
                                    _context.next = 24;
                                    break;
                                }

                                if (!(old.expire > new Date().getTime())) {
                                    _context.next = 23;
                                    break;
                                }

                                return _context.abrupt('return', old.value);

                            case 23:
                                this.tokens.remove(old);

                            case 24:
                                if (!_utils2.default.isEmpty(this.api)) {
                                    _context.next = 27;
                                    break;
                                }

                                console.warn('没有提供tokenApi地址用于获取upToken');
                                return _context.abrupt('return', '');

                            case 27:
                                _context.next = 29;
                                return this.query(value, this.queryAccessToken());

                            case 29:
                                token = _context.sent;

                                if (!token.value) {
                                    _context.next = 35;
                                    break;
                                }

                                this.tokens.push({ id: bucket + key, token: token });
                                return _context.abrupt('return', token.value);

                            case 35:
                                return _context.abrupt('return', '');

                            case 36:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function getToken() {
                return _ref2.apply(this, arguments);
            }

            return getToken;
        }()
    }, {
        key: 'uploadFile',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4, file, onProgress) {
                var bucket = _ref4.bucket,
                    key = _ref4.key;

                var _this2 = this;

                var token, config, param;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.next = 2;
                                return this.getToken(bucket, key);

                            case 2:
                                token = _context2.sent;

                                if (!_utils2.default.isEmpty(token)) {
                                    _context2.next = 5;
                                    break;
                                }

                                return _context2.abrupt('return', { success: false, msg: '获取upToken失败' });

                            case 5:
                                config = {
                                    headers: { 'Content-Type': 'multipart/form-data' },
                                    onUploadProgress: function onUploadProgress(evt) {
                                        if (onProgress && evt.total > 0) {
                                            evt.percent = Math.round(evt.loaded / evt.total * 100);
                                            onProgress(evt);
                                        }
                                    }
                                };
                                param = new FormData();

                                param.append('chunk', '0');
                                param.append('chunks', '1');
                                if (key) {
                                    param.append('key', key);
                                }
                                param.append('file', file, file.name);
                                param.append('token', token);
                                return _context2.abrupt('return', new _promise2.default(function (resolve) {
                                    _axios2.default.post(_this2.server, param, config).then(function (response) {
                                        var res = null;
                                        if (response.status == 200) {
                                            res = { success: true, data: response.data };
                                        } else {
                                            res = { success: false, msg: 'status=' + response.status, _raw: response.data };
                                        }
                                        resolve(res);
                                    }).catch(function (error) {
                                        var res = { success: false, msg: '请求数据异常', _raw: error };
                                        resolve(res);
                                    });
                                }));

                            case 13:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function uploadFile(_x3, _x4, _x5) {
                return _ref3.apply(this, arguments);
            }

            return uploadFile;
        }()
    }, {
        key: 'uploadBase64',
        value: function () {
            var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6, data, onProgress) {
                var bucket = _ref6.bucket,
                    key = _ref6.key;
                var url, token;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                data = data.replace(/^data:image\/(\w+);base64,/, '');
                                url = this.server + "/putb64/-1";

                                if (!_utils2.default.isEmpty(key)) {
                                    _context3.next = 4;
                                    break;
                                }

                                return _context3.abrupt('return', { success: false, msg: '必须有key值' });

                            case 4:
                                url += '/key/' + _utils2.default.base64.encode(key);

                                if (!(typeof XMLHttpRequest === 'undefined')) {
                                    _context3.next = 8;
                                    break;
                                }

                                alert('浏览器不支持上传');
                                return _context3.abrupt('return', { success: false, msg: '浏览器不支持上传' });

                            case 8:
                                _context3.next = 10;
                                return this.getToken(bucket, key);

                            case 10:
                                token = _context3.sent;

                                if (!_utils2.default.isEmpty(token)) {
                                    _context3.next = 13;
                                    break;
                                }

                                return _context3.abrupt('return', { success: false, msg: '获取upToken失败' });

                            case 13:
                                return _context3.abrupt('return', new _promise2.default(function (resolve, reject) {
                                    var xhr = new XMLHttpRequest();

                                    if (xhr.upload && onProgress) {
                                        xhr.upload.onprogress = function (evt) {
                                            if (onProgress && evt.total > 0) {
                                                evt.percent = Math.round(evt.loaded / evt.total * 100);
                                                onProgress(evt);
                                            }
                                        };
                                    }
                                    xhr.onreadystatechange = function () {
                                        if (xhr.readyState == 4) {
                                            if (xhr.status == 200) {
                                                var res = {};
                                                eval('res=' + xhr.responseText);
                                                res = { success: true, data: res };
                                                resolve(res);
                                            } else {
                                                var res = { success: false, msg: '保存失败', raw: xhr.responseText };
                                                resolve(res);
                                            }
                                        }
                                    };

                                    var contentType = 'application/octet-stream';
                                    if (key.indexOf('.jpg') > -1) contentType = 'image/jpeg';else if (key.indexOf('.png') > -1) contentType = 'image/png';else if (key.indexOf('.json') > -1) contentType = 'application/json';

                                    xhr.open("POST", url, true);
                                    xhr.setRequestHeader("Content-Type", contentType);
                                    xhr.setRequestHeader("Authorization", "UpToken " + token);
                                    xhr.send(data);
                                }));

                            case 14:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function uploadBase64(_x6, _x7, _x8) {
                return _ref5.apply(this, arguments);
            }

            return uploadBase64;
        }()
    }]);
    return QiniuClient;
}();

exports.default = QiniuClient;