'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _compare = require('./compare');

var _compare2 = _interopRequireDefault(_compare);

var _base = require('base-64');

var _base2 = _interopRequireDefault(_base);

var _vtype = require('./vtype');

var _vtype2 = _interopRequireDefault(_vtype);

var _date = require('./date');

var _date2 = _interopRequireDefault(_date);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _idSeed = 0;
exports.default = {
    compare: _compare2.default, base64: _base2.default, vtype: _vtype2.default, date: _date2.default,
    id: function id() {
        return 'netfere-' + ++_idSeed;
    },
    uuid: function uuid(norep) {
        var value = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0,
                v = c == 'x' ? r : r & 0x3 | 0x8;
            return v.toString(16);
        });
        if (norep) {
            return value;
        } else {
            return value.replace(new RegExp('-', 'gm'), '');
        }
    },
    br2ln: function br2ln(value) {
        return value.replace(new RegExp('<br>', 'gm'), '\n');
    },
    ln2br: function ln2br(value) {
        return value.replace(new RegExp('\n', 'gm'), '<br>');
    },
    cnmoney: function cnmoney(value, cs) {
        return '￥' + (value / (cs || 100)).toFixed(2);
    },
    filesize: function filesize(value) {
        var size = 0;
        if (value > 1024 * 1024) size = (value / 1024 / 1024).toFixed(1) + 'M';else if (value > 1024) size = (value / 1024).toFixed(1) + 'K';else size = value + 'B';
        return size;
    },
    noop: function noop() {
        return false;
    },
    rnd: function rnd(n, m) {
        var includeMax = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

        if (m < n) {
            var _ref = [m, n];
            n = _ref[0];
            m = _ref[1];
        }
        if (includeMax) {
            m = m + 1;
        }
        var num = Math.random() * (m - n) + n;
        num = parseInt(num, 10);
        return num;
    },
    rndString: function rndString() {
        var len = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 8;

        var $chars = 'ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz012345678';
        var maxPos = $chars.length;
        var pwd = '';
        for (var i = 0; i < len; i++) {
            pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
        }
        return pwd;
    },
    sleep: function sleep(time, callback) {
        time = time || 2000;
        return new _promise2.default(function (resolve, reject) {
            setTimeout(function () {
                if (typeof callback === 'function') {
                    callback();
                }
                resolve();
            }, time);
        });
    },
    getUrlQuery: function getUrlQuery(name, Url) {
        var reg = new RegExp("(^|\\?|&)" + name + "=([^&#]*)(\\s|&|#|$)", "i"),
            url = Url || location.href;
        if (reg.test(url)) return unescape(RegExp.$2.replace(/\+/g, " "));
        return "";
    },
    apply: function apply(object, config, defaults) {
        if (defaults) {
            this.apply(object, defaults);
        }
        if (object && config && (typeof config === 'undefined' ? 'undefined' : (0, _typeof3.default)(config)) === 'object') {
            for (var key in config) {
                object[key] = config[key];
            }
        }
        return object;
    },
    applyIf: function applyIf(object, config, defaults) {
        if (defaults) {
            this.apply(object, defaults);
        }
        for (var key in config) {
            if (object[key] !== undefined) {
                object[key] = config[key];
            }
        }
        return object;
    },
    applyNo: function applyNo(object, config, defaults) {
        if (defaults) {
            this.apply(object, defaults);
        }
        for (var key in config) {
            if (object[key] === undefined) {
                object[key] = config[key];
            }
        }
        return object;
    },
    isEmpty: function isEmpty(value) {
        var zero = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        return value === null || value === undefined || value === false || typeof value === 'string' && value === '' || typeof value === 'number' && value === 0 && zero || (0, _typeof3.default)(Array.isArray(value)) && value.length === 0 || (typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) === 'object' && (0, _keys2.default)(value).length === 0;
    },
    deepCopy: function deepCopy(source) {
        var _this = this;

        if (this.isEmpty(source)) {
            return source;
        }
        if (Array.isArray(source)) {
            var result = [];
            source.forEach(function (item) {
                result.push(_this.deepCopy(item));
            });
            return result;
        } else if ((typeof source === 'undefined' ? 'undefined' : (0, _typeof3.default)(source)) === 'object') {
            var result = {};
            for (var key in source) {
                result[key] = (0, _typeof3.default)(source[key]) === 'object' ? this.deepCopy(source[key]) : source[key];
            }
            return result;
        } else {
            return source;
        }
    },
    trim: function trim(value) {
        return value.replace(/\s*/g, '');
    },
    replaceHtml: function replaceHtml(html) {
        return html.replace(/\s*/g, '').replace(/<[^>]*>/g, '');
    },
    truncation: function truncation(content, len) {
        if (content.length < len) {
            return content;
        } else {
            content.substr(0, len) + '...';
        }
    },
    has: function has(object, key) {
        return object != null && Object.prototype.hasOwnProperty.call(object, key);
    },
    getChange: function getChange(newValue, oldValue) {
        var value = {};
        for (var key in newValue) {
            if (!(0, _compare2.default)(newValue[key], oldValue[key])) {
                value[key] = newValue[key];
            }
        }
        return value;
    },
    getFields: function getFields(array, fields) {
        var _this2 = this;

        var simple = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

        if ($.isEmpty(array)) {
            return [];
        }
        if (typeof fields === 'string') {
            fields = [fields];
        }
        var results = [];
        array.forEach(function (rec) {
            var item = {};
            fields.forEach(function (key) {
                if (_this2.has(rec, key)) {
                    item[key] = rec[key];
                }
            });
            if (!_this2.isEmpty(item)) {
                results.push(item);
            }
        });
        if (simple && fields.length === 1) {
            var arr = [];
            results.forEach(function (item) {
                var value = item[fields[0]];
                if (!arr.exists(value)) {
                    arr.push(value);
                }
            });
            return arr;
        } else {
            return results;
        }
    },
    init: function init() {
        Array.prototype.exists = function (item) {
            if (typeof item === 'function') {
                return this.find(item) !== undefined;
            } else {
                return this.indexOf(item) > -1;
            }
        };

        Array.prototype.remove = function (query) {
            if (typeof query === 'function') {
                var result = [];
                if (this.length === 0) {
                    return result;
                }
                var length = this.length;
                while (length--) {
                    var value = this[length];
                    if (query(value)) {
                        result.insert(0, value);
                        this.splice(length, 1);
                    }
                }
                return result;
            } else if ((typeof query === 'undefined' ? 'undefined' : (0, _typeof3.default)(query)) === 'object' || Array.isArray(query)) {
                var idx = this.indexOf(query);
                if (idx > -1) {
                    this.splice(idx, 1);
                    return [query];
                } else {
                    return this.remove(function (a) {
                        return (0, _compare2.default)(a, query);
                    });
                }
            } else {
                return this.remove(function (a) {
                    return a === query;
                });
            }
        };

        Array.prototype.insert = function (idx, item) {
            this.splice(idx, 0, item);
            return this;
        };

        Date.prototype.format = function (dirtyFormatStr, dirtyOptions) {
            return (0, _date2.default)(this).format(dirtyFormatStr, dirtyOptions);
        };

        Date.prototype.toString = function (type) {
            type = type || 'full';
            var o = {
                date: 'YYYY-MM-DD',
                time: 'hh:mm:ss'
            };
            type = o[type] || 'YYYY-MM-DD HH:mm:ss';
            return this.format(type);
        };

        String.prototype.replaceAll = function (s1, s2) {
            return this.replace(new RegExp(s1, "gm"), s2);
        };

        String.prototype.trim = function () {
            return this.replace(/\s*/g, '');
        };
    },
    getToken: function getToken(key) {
        var advance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

        try {
            var obj = JSON.parse(window.localStorage.getItem(key));
            if (obj && obj.expire > new Date().getTime() + advance * 1000) {
                return obj.token;
            } else {
                return null;
            }
        } catch (e) {
            return null;
        }
    },
    setToken: function setToken(key, value) {
        window.localStorage.setItem(key, (0, _stringify2.default)(value));
    },
    loadScript: function loadScript(url, callback) {
        var script = document.createElement("script");
        script.type = "text/javascript";
        if (script.readyState) {
            script.onreadystatechange = function () {
                if (script.readyState == "loaded" || script.readyState == "complete") {
                    script.onreadystatechange = null;
                    callback();
                }
            };
        } else {
            script.onload = function () {
                callback();
            };
        }
        script.src = url;
        document.getElementsByTagName("head")[0].appendChild(script);
    }
};