'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
    function install(Vue) {
        var setWechatTitle = function setWechatTitle(title, img) {
            if (title === undefined || window.document.title === title) {
                return;
            }
            document.title = title;
            var mobile = navigator.userAgent.toLowerCase();
            if (/iphone|ipad|ipod/.test(mobile)) {
                var iframe = document.createElement('iframe');
                iframe.style.display = 'none';

                iframe.setAttribute('src', img || '/favicon.ico');
                var iframeCallback = function iframeCallback() {
                    setTimeout(function () {
                        iframe.removeEventListener('load', iframeCallback);
                        document.body.removeChild(iframe);
                    }, 0);
                };
                iframe.addEventListener('load', iframeCallback);
                document.body.appendChild(iframe);
            }
        };
        Vue.directive('wechat-title', function (el, binding) {
            setWechatTitle(binding.value, el.getAttribute('img-set') || null);
        });
    }

    if ((typeof exports === 'undefined' ? 'undefined' : (0, _typeof3.default)(exports)) === 'object') {
        module.exports = install;
    } else if (typeof define === 'function' && define.amd) {
        define([], function () {
            return install;
        });
    } else if (window.Vue) {
        Vue.use(install);
    }
})();