'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

var _weixinJsSdk = require('weixin-js-sdk');

var _weixinJsSdk2 = _interopRequireDefault(_weixinJsSdk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

if (_weixinJsSdk2.default.hideOptionMenu) {
    _weixinJsSdk2.default.hide = _weixinJsSdk2.default.hideOptionMenu;
}

if (_weixinJsSdk2.default.closeWindow) {
    _weixinJsSdk2.default.close = _weixinJsSdk2.default.closeWindow;
}

var getApiList = function getApiList() {
    var apis = {
        menu: ['hideOptionMenu', 'showOptionMenu', 'hideMenuItems', 'showMenuItems', 'hideAllNonBaseMenuItem', 'showAllNonBaseMenuItem'],
        share: ['onMenuShareTimeline', 'onMenuShareAppMessage', 'onMenuShareQQ', 'onMenuShareWeibo', 'onMenuShareQZone'],
        voice: ['startRecord', 'stopRecord', 'onVoiceRecordEnd', 'playVoice', 'pauseVoice', 'stopVoice', 'onVoicePlayEnd', 'uploadVoice', 'downloadVoice', 'translateVoice'],
        image: ['chooseImage', 'previewImage', 'uploadImage', 'downloadImage', 'getLocalImgData'],
        card: ['addCard', 'chooseCard', 'openCard'],
        pay: ['chooseWXPay', 'openProductSpecificView', 'openAddress'],
        base: ['closeWindow', 'getNetworkType', 'scanQRCode'],
        location: ['openLocation', 'getLocation']
    };
    var arr = [];
    for (var key in apis) {
        apis[key].forEach(function (item) {
            arr.push(item);
        });
    }

    return arr;
};

_weixinJsSdk2.default.init = function (config) {
    _weixinJsSdk2.default.error = function (res) {
        console.warn(res);
    };
    config = _utils2.default.apply({}, config, {
        beta: true,
        debug: false,
        jsApiList: getApiList()
    });

    ['appId', 'timestamp', 'nonceStr', 'signature'].forEach(function (key) {
        if (!config[key]) {
            console.warn('微信jssdk初始化缺少 ' + key + ' 参数');
        }
    });
    _weixinJsSdk2.default.ready(function () {
        if (typeof config.init === 'function') {
            config.init(_weixinJsSdk2.default);
        }
    });
    _weixinJsSdk2.default.config(config);

    return;
    _weixinJsSdk2.default.checkJsApi({
        jsApiList: config.jsApiList,
        success: function success(res) {
            _weixinJsSdk2.default.checkResult = res.checkResult || null;
        }
    });
};

var getLocalImgData = function getLocalImgData(localId) {
    return new _promise2.default(function (resolve) {
        try {
            _weixinJsSdk2.default.getLocalImgData({
                localId: localId,
                success: function success(res) {
                    if (!res.localData) {
                        resolve({ id: localId, src: localId });
                        return;
                    }
                    var img = res.localData;
                    if (!img.startsWith('data:image')) {
                        img = 'data:image/jpeg;base64,' + img;
                    } else {
                        img = img.replace('jgp', 'jpeg');
                    }
                    resolve({ id: localId, src: img });
                },
                error: function error(e) {
                    resolve({ id: localId, src: localId });
                }
            });
        } catch (e) {
            resolve({ id: localId, src: localId });
        }
    });
};

_weixinJsSdk2.default.getImage = function (_ref) {
    var _this = this;

    var _ref$count = _ref.count,
        count = _ref$count === undefined ? 9 : _ref$count,
        _ref$sizeType = _ref.sizeType,
        sizeType = _ref$sizeType === undefined ? ['compressed', 'original'] : _ref$sizeType,
        _ref$sourceType = _ref.sourceType,
        sourceType = _ref$sourceType === undefined ? ['album', 'camera'] : _ref$sourceType,
        _ref$success = _ref.success,
        success = _ref$success === undefined ? _utils2.default.noop : _ref$success,
        _ref$fail = _ref.fail,
        fail = _ref$fail === undefined ? _utils2.default.noop : _ref$fail,
        _ref$complete = _ref.complete,
        complete = _ref$complete === undefined ? _utils2.default.noop : _ref$complete;

    return new _promise2.default(function (resolve) {
        var photos = [];
        _weixinJsSdk2.default.chooseImage({
            count: count,
            sizeType: sizeType,
            sourceType: sourceType,
            success: function () {
                var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(res) {
                    var i;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    i = 0;

                                case 1:
                                    if (!(i < res.localIds.length)) {
                                        _context.next = 10;
                                        break;
                                    }

                                    _context.t0 = photos;
                                    _context.next = 5;
                                    return getLocalImgData(res.localIds[i]);

                                case 5:
                                    _context.t1 = _context.sent;

                                    _context.t0.push.call(_context.t0, _context.t1);

                                case 7:
                                    i++;
                                    _context.next = 1;
                                    break;

                                case 10:
                                    resolve(photos);

                                case 11:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, _this);
                }));

                return function success(_x) {
                    return _ref2.apply(this, arguments);
                };
            }(),
            fail: function fail(res) {
                resolve([]);
            },
            complete: complete
        });
    });
};

_weixinJsSdk2.default.upload = function (_ref3) {
    var _ref3$type = _ref3.type,
        type = _ref3$type === undefined ? 'photo' : _ref3$type,
        _ref3$mask = _ref3.mask,
        mask = _ref3$mask === undefined ? false : _ref3$mask,
        localId = _ref3.localId;

    var isShowProgressTips = mask ? 1 : 0;
    return new _promise2.default(function (resolve) {
        try {
            if (type === 'voice') {
                _weixinJsSdk2.default.uploadVoice({
                    localId: localId,
                    isShowProgressTips: isShowProgressTips,
                    success: function success(res) {
                        resolve({ success: true, media_id: res.serverId });
                    },
                    fail: function fail(res) {
                        resolve({ success: false, msg: '上传失败' });
                    }
                });
            } else if (type === 'photo') {
                _weixinJsSdk2.default.uploadImage({
                    localId: localId,
                    isShowProgressTips: isShowProgressTips,
                    success: function success(res) {
                        resolve({ success: true, media_id: res.serverId });
                    },
                    fail: function fail() {
                        resolve({ success: false, msg: '上传失败' });
                    }
                });
            }
        } catch (e) {
            resolve({ success: false, msg: '上传失败' + e.toString() });
        }
    });
};

exports.default = {
    install: function install(Vue) {
        Vue.prototype.$wechat = _weixinJsSdk2.default;
        Vue.$wechat = _weixinJsSdk2.default;
    }
};