import utils from '../utils';
import ajax from '../ajax';
import modal from './modal';


export default {
    install(Vue,$ele,Config) {
        if ($ele) {
            let cfg = modal($ele);
            let events =opt=> {
                return {
                    mask(){
                        if(typeof opt.mask==='string'){
                            cfg.mask(opt.mask)
                        }else if(typeof opt.mask==='function'){
                            opt.mask(true)
                        }else{
                            return false
                        }
                    },
                    unmask(){
                        if(typeof opt.mask==='string'){
                            cfg.unmask()
                        }else if(typeof opt.mask==='function'){
                            opt.mask(false)
                        }else{
                            return false
                        }
                    }
                }
            }
            Object.assign(utils, cfg, {
                query: function (options) {
                    if(!options.err){
                        options.err=res=>{cfg.info(res.msg || '未知错误')}
                    }
                    options = utils.apply({}, events(options), options);
                    if (options.confirm) {
                        let yes = () => {
                            delete options.confirm
                            ajax.query(options)
                        }
                        if (typeof options.confirm === 'string') {
                            cfg.confirm(options.confirm, yes)
                        } else if (typeof options.confirm === 'object') {
                            if (typeof options.confirm.yes === 'object') {
                                yes = { text: options.confirm.yes.text || '确定', handler: yes }
                            }
                            cfg.confirm(
                                options.confirm.title || '', options.confirm.content || '', yes, options.confirm.no
                            )
                        } else {
                            yes()
                        }
                    }else{
                        ajax.query(options)
                    }
                },
                fetch(options){
                    if(options.confirm){
                        delete options.confirm
                    }
                    options = utils.apply({}, events(options), options);
                    return ajax.fetch(options)
                }
            })
        }
        

        Vue.prototype.$ = utils
        Vue.$ = utils
        window.$ = utils

        if (Config) {
            Vue.prototype.$cfg = Config
            Vue.$cfg = Config
            window.$cfg = Config
        }
    }
}