
let MessageBox, Message, Loading, loadingInstance


const cfg = {
    alert(title, content, onHide,html) {
        if (arguments.length == 0) {
            return
        }
        if (arguments.length == 1) {
            content = title
            title = ''
            onHide = function () { }
        } else if (arguments.length == 2) {
            if (typeof content == 'function') {
                onHide = content
                content = title
                title = ''
            } else {
                onHide = function () { }
            }
        }
        MessageBox.alert(content, title, {
            confirmButtonText: '确定',
            callback: action => {
                onHide()
            },
            dangerouslyUseHTMLString:html || false
        })
    },
    toast(type, text, onHide,duration=3000) {
        onHide = onHide || function () { }
        return Message({
            type: type,
            message: text,
            duration
        })
    },
    success(text, onHide) {
        return this.toast('success', text, onHide)
    },
    error(text, onHide) {
        return this.toast('error', text, onHide)
    },
    info(text, onHide) {
        return this.toast('info', text, onHide)
    },
    confirm(title, content, yes, no) {
        if (arguments.length == 1) {
            content = title
            title = ''
            yes = function () { }
            no = function () { }
        } else if (arguments.length == 2) {
            if (typeof content == 'function' || typeof content == 'object') {
                yes = content
                no = function () { }
                content = title
                title = ''
            } else {
                yes = function () { }
                no = function () { }
            }
        } else {
            no = no || function () { }
        }
        if (typeof yes == 'function') {
            yes = { text: '确定', handler: yes }
        }
        if (typeof no == 'function') {
            no = { text: '取消', handler: no }
        }
        MessageBox.confirm(content, title, {
            confirmButtonText: yes.text,
            cancelButtonText: no.text,
            type: 'warning',
            dangerouslyUseHTMLString:false
        }).then(
            () => {
                yes.handler()
            }
            ).catch(
            () => {
                no.handler()
            }
            )
    },
    mask(text) {
        loadingInstance = Loading.service({ text: text });
    },
    unmask() {
        try {
            if (loadingInstance) {
                loadingInstance.close()
            }
        } catch (e) {
            console.log(e)
        }
    },
    prompt(options,vm) {
        options = $.apply({}, options, {
            title: '提示', msg: '', error: '',type:'text',
            regex: v => { return $.isEmpty(v) ? '不能为空' : true },
            value: null, handler: () => { },
            loading: (ing, instance) => {
                vm.$set(instance, 'confirmButtonLoading', ing)
                if (ing) {
                    vm.$set(instance, 'confirmButtonText', '提交中...')
                } else if (!instance.confirmButtonLoading) {
                    instance.close()
                }
            }
        })
        if (typeof options.handler === 'function') {
            options.handler = { text: '确定', handler: options.handler }
        }

        let cfg = {
            confirmButtonText: options.handler.text,
            cancelButtonText: '取消',
            inputErrorMessage: options.error,
            inputValue: options.value,
            inputType:options.type,
            inputPlaceholder:options.emptyText || '',
            beforeClose: (action, instance) => {
                if (action === 'confirm') {
                    options.handler.handler(instance.inputValue, ing => {
                        options.loading(ing, instance)
                    })
                } else if (!instance.confirmButtonLoading) {
                    instance.close()
                }
            }
        }
        if (options.regex) {
            if (typeof options.regex === 'function') {
                cfg.inputValidator = options.regex
            } else {
                cfg.inputPattern = options.regex
            }
        }
        MessageBox.prompt(options.msg || '-', options.title, cfg).then($.noop).catch($.noop)
    }
}

export default function ($ele) {
    MessageBox = $ele.MessageBox, Message = $ele.Message, Loading = $ele.Loading
    return cfg
}
