import utils from '../utils';
import ajax from '../ajax';
import modal from './modal'
import wechatTitle from './wechat-title'
import wechatJssdk from './wechat'
export default {
    install(Vue,Config) {
        if (Vue.$vux) {
            let $vux = {}
            for (let key of ['alert', 'confirm', 'toast', 'loading']) {
                $vux[key] = Vue.$vux[key]
            }
            let cfg = modal($vux);
            let events =opt=> {
                return {
                    err:opt.err || function(res){cfg.info(res.msg || '未知错误')},
                    mask(){
                        if(typeof opt.mask==='string'){
                            cfg.mask(opt.mask)
                        }else if(typeof opt.mask==='function'){
                            opt.mask(true)
                        }else{
                            return false
                        }
                    },
                    unmask(){
                        if(typeof opt.mask==='string'){
                            cfg.unmask()
                        }else if(typeof opt.mask==='function'){
                            opt.mask(false)
                        }else{
                            return false
                        }
                    }
                }
            }
            Object.assign(utils, cfg, {
                query: function (options) {
                    options = utils.apply({}, events(options), options);
                    if (options.confirm) {
                        let yes = () => {
                            delete options.confirm
                            ajax.query(options)
                        }
                        if (typeof options.confirm === 'string') {
                            cfg.confirm(options.confirm, yes)
                        } else if (typeof options.confirm === 'object') {
                            if (typeof options.confirm.yes === 'object') {
                                yes = { text: options.confirm.yes.text || '确定', handler: yes }
                            }
                            cfg.confirm(
                                options.confirm.title || '', options.confirm.content || '', yes, options.confirm.no
                            )
                        } else {
                            yes()
                        }
                    }else{
                        ajax.query(options)
                    }
                },
                fetch(options){
                    if(options.confirm){
                        delete options.confirm
                    }
                    options = utils.apply({}, events(options), options);
                    return ajax.fetch(options)
                }
            })
        }

        Vue.use(wechatTitle)
        Vue.use(wechatJssdk)
        Vue.prototype.$ = utils
        Vue.$ = utils
        window.$ = utils

        if (Config) {
            Vue.prototype.$cfg = Config
            Vue.$cfg = Config
            window.$cfg = Config
        }
        //Object.definePrototype(Vue.prototype, '$leyu', { value: utils });
        //使用 Object.defineProperty 定义对象属性，如果不在属性描述器中额外说明，则该属性就是默认只读的，保护引入的库不被重新赋值。
    }
}