let $vux = null
import _ from '../utils'

let modal = {
    alert(title, content, onHide) {
        if (arguments.length == 0) {
            return
        }
        if (arguments.length == 1) {
            content = title
            title = ''
            onHide = function() {}
        } else if (arguments.length == 2) {
            if (typeof content == 'function') {
                onHide = content
                content = title
                title = ''
            } else {
                onHide = function() {}
            }
        }
        if ($vux.alert) {
            $vux.alert.show({
                title,
                content,
                onHide
            })
        }
    },
    toast(type, text, onHide) {
        onHide = onHide || function() {}
        if ($vux.toast) {
            $vux.toast.show({ text, type, onHide, position: 'top' })
        }
    },
    success(text, onHide) {
        this.toast('success', text, onHide)
    },
    error(text, onHide) {
        this.toast('warn', text, onHide)
    },
    info(text, onHide) {
        this.toast('text', text, onHide)
    },
    confirm(title, content, yes, no) {
        let setting = {}
        if (typeof title === 'object') {
            setting = title
        } else {
            if (arguments.length === 1) {
                content = title
            } else if (arguments.length === 2) {
                if (typeof content === 'function' || typeof content === 'object') {
                    yes = content
                    no = _.noop
                    content = title
                    title = ''
                }
            }
            if (!yes) {
                yes = _.noop
            }
            if (!no) {
                no = _.noop
            }
            setting = { title, content, yes, no }
        }
        setting = _.apply({}, setting, { title: '', content: '', yes: { text: '确定', handler: _.noop }, no: { text: '取消', handler: _.noop } })

        if (typeof setting.yes === 'function') {
            setting.yes = { text: '确定', handler: yes }
        }
        if (typeof setting.no === 'function') {
            setting.no = { text: '取消', handler: no }
        }

        if ($vux.confirm) {
            $vux.confirm.show({
                title: setting.title,
                content: setting.content,
                confirmText: setting.yes.text,
                cancelText: setting.no.text,
                onConfirm: setting.yes.handler,
                onCancel: setting.no.handler
            })
        }
    },
    mask(text) {
        if ($vux.loading) {
            $vux.loading.show({ text })
        }
    },
    unmask() {
        if ($vux.loading) {
            $vux.loading.hide()
        }
    }
}
export default function(vux) {
    $vux = vux
    return modal
}